'Oct 17

Imports System.IO

'(so far) this program reads two data files and 
'uses the data to make arrays of information 
'pertaining to Beatles songs and albums

Public Class FrmBeatles
    Dim MyLocation As String

    'arrays based on data from BeatlesAlbums.txt
    Dim AlbumCode As String()
    Dim AlbumTitle As String()
    Dim AlbumImage As String()

    'arrays based on data from BeatlesSongs.txt
    Dim Song As String()
    Dim SongAlbumCode As String()


    '***********************************************
    'when form loads read two data files, make arrays 
    'and place song titles in listbox
    Private Sub FrmBeatles_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim MyStreamReader As StreamReader  'object to read file
        Dim MyFile As String                'string to hold entire contents of file
        Dim MyLine As String()              'array of lines from file
        Dim MyToken As String()             'array of token when line is parsed
        Dim i As Integer                    'loop counter


        MyLocation = Directory.GetCurrentDirectory

        'attempt to read all of file contents and assign it 
        'to MyFile variable
        Try
            MyStreamReader = New StreamReader(MyLocation & "\BeatlesAlbums.txt")
            MyFile = MyStreamReader.ReadToEnd
            MyStreamReader.Close()
        Catch ex As Exception
            MsgBox("Problem reader album file.")
            Exit Sub
        End Try

        'parse file contents of return character
        MyLine = MyFile.Split(vbCrLf)

        'instantiate arrays
        AlbumCode = New String(MyLine.Length - 1) {}
        AlbumTitle = New String(MyLine.Length - 1) {}
        AlbumImage = New String(MyLine.Length - 1) {}

        'loop through lines of data, parse them, 
        'assign the tokens to the appropriate array 
        'elements
        For i = 0 To MyLine.Length - 1
            MyLine(i) = MyLine(i).Trim
            MyToken = MyLine(i).Split(",")
            AlbumCode(i) = MyToken(0).Trim
            AlbumTitle(i) = MyToken(1).Trim
            AlbumImage(i) = MyToken(2).Trim
        Next

        'repeat above for second data file
        Try
            MyStreamReader = New StreamReader(Directory.GetCurrentDirectory & "\BeatlesSongs.txt")
            MyFile = MyStreamReader.ReadToEnd
            MyStreamReader.Close()
        Catch ex As Exception
            MsgBox("Problem reader album file.")
            Exit Sub
        End Try

        MyLine = MyFile.Split(vbCrLf)
        Song = New String(MyLine.Length - 1) {}
        SongAlbumCode = New String(MyLine.Length - 1) {}

        For i = 0 To MyLine.Length - 1
            MyLine(i) = MyLine(i).Trim
            MyToken = MyLine(i).Split(",")
            Song(i) = MyToken(0).Trim
            SongAlbumCode(i) = MyToken(1).Trim
            lstSongs.Items.Add(Song(i))     'place song titles in listbox
        Next

    End Sub

    '*************************************************
    'when user selects a song, place the corresponding 
    'album cover image into a picturebox 
    Private Sub lstSongs_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstSongs.SelectedIndexChanged
        'get song index from listbox
        'get album code from SongAlbumCode array
        'find index of same code in AlbumCode array
        'use the image with that index

        'MsgBox(SongAlbumCode(lstSongs.SelectedIndex))
        Dim SearchIndex = Array.IndexOf(AlbumCode, SongAlbumCode(lstSongs.SelectedIndex))
        'MsgBox(SearchIndex)

        picAlbum.Image = Image.FromFile(MyLocation & "\" & AlbumImage(SearchIndex))
    End Sub
End Class
